<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content interface">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Interfaces</li>
  <li>TypeRecord</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/common/events/strict-event-emitter.ts</code>
        </p>



        <section>
            <h3 id="index">Index</h3>
            <table class="table table-sm table-bordered index-table">
                <tbody>
                    <tr>
                        <td class="col-md-4">
                            <h6><b>Properties</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                            <span class="modifier">Optional</span>
                                        <a href="# _emitterType"> _emitterType</a>
                                </li>
                                <li>
                                            <span class="modifier">Optional</span>
                                        <a href="# _emitType"> _emitType</a>
                                </li>
                                <li>
                                            <span class="modifier">Optional</span>
                                        <a href="# _eventsType"> _eventsType</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
            </table>
        </section>



            <section>
                <h3 id="inputs">Properties</h3>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name=" _emitterType"></a>
                                        <span class="name"><b> _emitterType</b><a href="# _emitterType"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code> _emitterType:     <code>T</code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>    <code>T</code>

                                        </td>
                                    </tr>

                                    <tr>
                                        <td class="col-md-4">
                                            <i>Optional</i>
                                        </td>
                                    </tr>




                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name=" _emitType"></a>
                                        <span class="name"><b> _emitType</b><a href="# _emitType"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code> _emitType:     <code>V</code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>    <code>V</code>

                                        </td>
                                    </tr>

                                    <tr>
                                        <td class="col-md-4">
                                            <i>Optional</i>
                                        </td>
                                    </tr>




                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name=" _eventsType"></a>
                                        <span class="name"><b> _eventsType</b><a href="# _eventsType"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code> _eventsType:     <code>U</code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>    <code>U</code>

                                        </td>
                                    </tr>

                                    <tr>
                                        <td class="col-md-4">
                                            <i>Optional</i>
                                        </td>
                                    </tr>




                        </tbody>
                    </table>
            </section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">declare const assignmentCompatibilityHack: unique symbol;

// Returns any keys of TRecord with the type of TMatch
export type MatchingKeys&lt;
    TRecord,
    TMatch,
    K extends keyof TRecord &#x3D; keyof TRecord
    &gt; &#x3D; K extends (TRecord[K] extends TMatch ? K : never) ? K : never;

// Returns any property keys of Record with a void type
export type VoidKeys&lt;Record&gt; &#x3D; MatchingKeys&lt;Record, void&gt;;

// TODO: Stash under a symbol key once TS compiler bug is fixed
export interface TypeRecord&lt;T, U, V&gt; {
    &#x27; _emitterType&#x27;?: T;
    &#x27; _eventsType&#x27;?: U;
    &#x27; _emitType&#x27;?: V;
}

export type ReturnTypeOfMethod&lt;T&gt; &#x3D; T extends (...args: any[]) &#x3D;&gt; any
    ? ReturnType&lt;T&gt;
    : void;

export type ReturnTypeOfMethodIfExists&lt;T, S extends string&gt; &#x3D; S extends keyof T
    ? ReturnTypeOfMethod&lt;T[S]&gt;
    : void;

export type InnerEEMethodReturnType&lt;T, TValue, FValue&gt; &#x3D; T extends (
    ...args: any[]
) &#x3D;&gt; any
    ? ReturnType&lt;T&gt; extends void | undefined ? FValue : TValue
    : FValue;

export type EEMethodReturnType&lt;
    T,
    S extends string,
    TValue,
    FValue &#x3D; void
    &gt; &#x3D; S extends keyof T ? InnerEEMethodReturnType&lt;T[S], TValue, FValue&gt; : FValue;

export type ListenerType&lt;T&gt; &#x3D; [T] extends [(...args: infer U) &#x3D;&gt; any]
    ? U
    : [T] extends [void] ? [] : [T];

// EventEmitter method overrides
export type OverriddenMethods&lt;
    TEmitter,
    TEventRecord,
    TEmitRecord &#x3D; TEventRecord
    &gt; &#x3D; {
        on&lt;P extends keyof TEventRecord, T&gt;(
            this: T,
            event: P,
            listener: (...args: ListenerType&lt;TEventRecord[P]&gt;) &#x3D;&gt; void
        ): EEMethodReturnType&lt;TEmitter, &#x27;on&#x27;, T&gt;;
        on(
            event: typeof assignmentCompatibilityHack,
            listener: (...args: any[]) &#x3D;&gt; any
        ): void;

        addListener&lt;P extends keyof TEventRecord, T&gt;(
            this: T,
            event: P,
            listener: (...args: ListenerType&lt;TEventRecord[P]&gt;) &#x3D;&gt; void
        ): EEMethodReturnType&lt;TEmitter, &#x27;addListener&#x27;, T&gt;;
        addListener(
            event: typeof assignmentCompatibilityHack,
            listener: (...args: any[]) &#x3D;&gt; any
        ): void;

        addEventListener&lt;P extends keyof TEventRecord, T&gt;(
            this: T,
            event: P,
            listener: (...args: ListenerType&lt;TEventRecord[P]&gt;) &#x3D;&gt; void
        ): EEMethodReturnType&lt;TEmitter, &#x27;addEventListener&#x27;, T&gt;;
        addEventListener(
            event: typeof assignmentCompatibilityHack,
            listener: (...args: any[]) &#x3D;&gt; any
        ): void;

        removeListener&lt;P extends keyof TEventRecord, T&gt;(
            this: T,
            event: P,
            listener: (...args: any[]) &#x3D;&gt; any
        ): EEMethodReturnType&lt;TEmitter, &#x27;removeListener&#x27;, T&gt;;
        removeListener(
            event: typeof assignmentCompatibilityHack,
            listener: (...args: any[]) &#x3D;&gt; any
        ): void;

        removeEventListener&lt;P extends keyof TEventRecord, T&gt;(
            this: T,
            event: P,
            listener: (...args: any[]) &#x3D;&gt; any
        ): EEMethodReturnType&lt;TEmitter, &#x27;removeEventListener&#x27;, T&gt;;
        removeEventListener(
            event: typeof assignmentCompatibilityHack,
            listener: (...args: any[]) &#x3D;&gt; any
        ): void;

        once&lt;P extends keyof TEventRecord, T&gt;(
            this: T,
            event: P,
            listener: (...args: ListenerType&lt;TEventRecord[P]&gt;) &#x3D;&gt; void
        ): EEMethodReturnType&lt;TEmitter, &#x27;once&#x27;, T&gt;;
        once(
            event: typeof assignmentCompatibilityHack,
            listener: (...args: any[]) &#x3D;&gt; any
        ): void;

        emit&lt;P extends keyof TEmitRecord, T&gt;(
            this: T,
            event: P,
            ...args: ListenerType&lt;TEmitRecord[P]&gt;
        ): EEMethodReturnType&lt;TEmitter, &#x27;emit&#x27;, T&gt;;
        emit(event: typeof assignmentCompatibilityHack, ...args: any[]): void;
    };

export type OverriddenKeys &#x3D; keyof OverriddenMethods&lt;any, any, any&gt;;

export type StrictEventEmitter&lt;
    TEmitterType,
    TEventRecord,
    TEmitRecord &#x3D; TEventRecord,
    UnneededMethods extends Exclude&lt;OverriddenKeys, keyof TEmitterType&gt; &#x3D; Exclude&lt;
        OverriddenKeys,
        keyof TEmitterType
    &gt;,
    NeededMethods extends Exclude&lt;OverriddenKeys, UnneededMethods&gt; &#x3D; Exclude&lt;
        OverriddenKeys,
        UnneededMethods
    &gt;
    &gt; &#x3D;
    // Store the type parameters we&#x27;ve instantiated with so we can refer to them later
    TypeRecord&lt;TEmitterType, TEventRecord, TEmitRecord&gt; &amp;
    // Pick all the methods on the original type we aren&#x27;t going to override
    Pick&lt;TEmitterType, Exclude&lt;keyof TEmitterType, OverriddenKeys&gt;&gt; &amp;
    // Finally, pick the needed overrides (taking care not to add an override for a method
    // that doesn&#x27;t exist)
    Pick&lt;
        OverriddenMethods&lt;TEmitterType, TEventRecord, TEmitRecord&gt;,
        NeededMethods
    &gt;;

export default StrictEventEmitter;

export type NoUndefined&lt;T&gt; &#x3D; T extends undefined ? never : T;

export type StrictBroadcast&lt;
    TEmitter extends TypeRecord&lt;any, any, any&gt;,
    TEmitRecord extends NoUndefined&lt;TEmitter[&#x27; _emitType&#x27;]&gt; &#x3D; NoUndefined&lt;
        TEmitter[&#x27; _emitType&#x27;]
    &gt;,
    VK extends VoidKeys&lt;TEmitRecord&gt; &#x3D; VoidKeys&lt;TEmitRecord&gt;,
    NVK extends Exclude&lt;keyof TEmitRecord, VK&gt; &#x3D; Exclude&lt;keyof TEmitRecord, VK&gt;
    &gt; &#x3D; {
        &lt;E extends NVK&gt;(event: E, request: TEmitRecord[E]): any;
        &lt;E extends VK&gt;(event: E): any;
    };

export type EventNames&lt;
    TEmitter extends TypeRecord&lt;any, any, any&gt;,
    TEventRecord extends NoUndefined&lt;TEmitter[&#x27; _eventsType&#x27;]&gt; &#x3D; NoUndefined&lt;
        TEmitter[&#x27; _eventsType&#x27;]
    &gt;,
    TEmitRecord extends NoUndefined&lt;TEmitter[&#x27; _emitType&#x27;]&gt; &#x3D; NoUndefined&lt;
        TEmitter[&#x27; _emitType&#x27;]
    &gt;
    &gt; &#x3D; keyof TEmitRecord | keyof TEventRecord;

export type OnEventNames&lt;
    TEmitter extends TypeRecord&lt;any, any, any&gt;,
    TEventRecord extends NoUndefined&lt;TEmitter[&#x27; _eventsType&#x27;]&gt; &#x3D; NoUndefined&lt;
        TEmitter[&#x27; _eventsType&#x27;]
    &gt;,
    TEmitRecord extends NoUndefined&lt;TEmitter[&#x27; _emitType&#x27;]&gt; &#x3D; NoUndefined&lt;
        TEmitter[&#x27; _emitType&#x27;]
    &gt;
    &gt; &#x3D; keyof TEventRecord;

export type EmitEventNames&lt;
    TEmitter extends TypeRecord&lt;any, any, any&gt;,
    TEventRecord extends NoUndefined&lt;TEmitter[&#x27; _eventsType&#x27;]&gt; &#x3D; NoUndefined&lt;
        TEmitter[&#x27; _eventsType&#x27;]
    &gt;,
    TEmitRecord extends NoUndefined&lt;TEmitter[&#x27; _emitType&#x27;]&gt; &#x3D; NoUndefined&lt;
        TEmitter[&#x27; _emitType&#x27;]
    &gt;
    &gt; &#x3D; keyof TEmitRecord;</code></pre>
    </div>
</div>


                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'interface';
            var COMPODOC_CURRENT_PAGE_URL = 'TypeRecord.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
